#include <NEXTION_RECEPCION.h>

#include "stdlib.h"

#FUSES NOMCLR

#use rs232(baud=9600, stop=1, parity=N, xmit=PIN_C6, rcv=PIN_C7, bits=8)

char recibido[15];

int8 val01_num = 0;
int8 val02_num = 0;

void datos();

#int_rda
void recibe()
{
   memset(recibido, 0, sizeof(recibido)); //limpia los registros de la varible
   int8 i=0;
   while(true)
   {
      recibido[i]=getc();//RECIBE EL CARACTER

      if (recibido[i] == 255 ){return;} //inicio de pantalla nextion

      if(recibido[i] == '\n')//busca el salto de linea \r
      {
         recibido[i-1] = '\0';  //  \r = \0 (caracter nulo)
         recibido[i] = '\0';   //  \n = \0 (caracter nulo)

         datos();
         return;
      }
      i++;
   }
}

void datos()
{
   signed int8 result;

   char ID_val[6];
   char num[4];

   char val01[6] = "val01";
   char val02[6] = "val02";

   memset(ID_val, 0, sizeof(ID_val)); //limpia los registros de la varible ID_val
   memset(num, 0, sizeof(num)); //limpia los registros de la varible num

       for (int i=0; i<=4; ++i)
      {
         ID_val[i] = recibido[i]; //identifica la variable
      }

      for (int i=0; i<=2; ++i)
      {
         num[i] = recibido[i+5]; //guarda el valor de la variable
      }

      result = strcmp(ID_val, val01);//compara, si son iguales (0), no (+-1)

      if(result==0)
      {
         val01_num = (int8)atoi(num);  //convierte la cadena en un numero de 8bits
         return;
      }

      result = strcmp(ID_val, val02);

      if(result==0)
      {
         val02_num = (int8)atoi(num); //convierte la cadena en un numero de 8bits
         return;
      }
}

void main()
{

   enable_interrupts(int_rda);
   enable_interrupts(global);
   
   setup_timer_2(T2_DIV_BY_16,24,1);// seal de 12.5kHz o 80 us
   
   setup_ccp1(CCP_PWM);//habilita el pin ccp1
   setup_ccp2(CCP_PWM);//habilita el pin ccp2

   while(TRUE)
   {
      set_pwm1_duty((int16)val01_num);// 100% duty clicle = numero 100
      set_pwm2_duty((int16)val02_num);
      //TODO: User Code
   }
}
